#include <stdio.h>

/*
 * 08/02/09: This ``clever'' code is taken from the ridiculously contrived
 * Python memory allocator, which uses various nonstandard C kludges and
 * is VERY hard to understand (there are hundreds of lines of comments
 * which in part acknowledge this).
 *
 * The data structure is an array of struct pointers, which point to the
 * array itself. If all goes well and the compiler inserts no padding,
 * then the struct members (which are also pointers to struct) happen to
 * map to the other array elements, such that they can be used to
 * traverse the array like a list. This ONLY works if only the struct
 * pointers are accessed, because there is not enough storage for the
 * other struct members
 */
struct pool_header {
	union { void *_padding; unsigned count; } ref;
	void *freeblock;
	struct pool_header *nextpool;
	struct pool_header *prevpool;
	unsigned arenaindex;
	unsigned szidx; 
	unsigned nextoffset; 
	unsigned maxnextoffset; 
};

typedef struct pool_header *poolp;

#define PTA(x)  ((poolp )((unsigned char *)&(usedpools[2*(x)]) - 2*sizeof(void *)))
#define PT(x)   PTA(x), PTA(x)


static poolp usedpools[1024] = {
	PT(0), PT(1), PT(2), PT(3), PT(4), PT(5), PT(6), PT(7)
};


void *nonsense = PTA(0);
int
main() {
	printf("%u\n", (unsigned)((unsigned char *)usedpools - (unsigned char *)usedpools[0]));
	/* This should print a null pointer */
	printf("%p\n", usedpools[0]->freeblock);
}

